Subject: Re: Using archaic I2C with OF

From: Gary Thomas <[email-masked]>
Date: Mon, 04 May 2009 06:19:14 -0600

Wolfram Sang wrote:
>> Post this on the i2c list. Jean has made an effort to convert all
>> drivers. He must have missed that one.
>>     
>
> What Jean did was converting all drivers who used the legacy i2c-binding to use
> the new binding which is a lot better suited to the driver model. The above
> mentioned driver already uses the new binding.
>
> The problem coming up here is another issue and also long standing and not yet
> solved. There are drivers which require platform_data with function pointers.
> You cannot encode function pointers to the device tree.
>
> One solution is to create a custom driver for your board with the needed
> specific function and create a platform device from there. Sometimes it
> works to add a bit more info to the device tree (e.g. some gpios) and
> parse it via an of_wrapper around the platform driver.
>   
So somehow, I need to create a platform driver, possibly inside an
of_wrapper, which
eventually instantiates an I2C device on a particular bus, with my
specific platform
data. 

Sorry, but I'm lost here.  How do I untangle this maze of twisty little
passages?

-- 
------------------------------------------------------------
Gary Thomas                 |  Consulting for the
MLB Associates              |    Embedded world
------------------------------------------------------------